Attribute VB_Name = "GetCRC"
Option Explicit

'------------------------------------------------------
'
' getcrc.bas -- CRC32ACRC16擾W[
'
'------------------------------------------------------

'{RtlMoveMemoryƂ֐APIł
'oCgz񂩂oCgz
Public Declare Sub CopyValtoVal Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)

Private CRC32Table(255) As Long
Private CRC16Table(255) As Long

Function GetCRC16(buf() As Byte) As String
'oCgz񂩂CRC16擾
Dim i&, l&
Dim b As Long
Dim CRC As String
Dim lCRC As Long

'e[u擾
If CRC16Table(255) = 0 Then Call SetCRC16Table

l = UBound(buf)

'l
lCRC = &HFFFF&

'1oCg
For i = 0 To l
  b = buf(i) Xor (lCRC And &HFF)

  '8rbgEVtg
  'Long^̉2oCgȂ̂ŏɐ
  lCRC = (lCRC \ 256) Xor CRC16Table(b)
Next

CRC = Hex(lCRC)
If Len(CRC) < 4 Then CRC = String(4 - Len(CRC), "0") + CRC

GetCRC16 = CRC

End Function

Function GetCRC32(buf() As Byte) As String
'oCgz񂩂CRC32擾
Dim i&, l&
Dim b As Long
Dim CRC As String
Dim lCRC&

'e[u擾
If CRC32Table(1) = 0 Then Call SetCRC32Table

l = UBound(buf)

'l0xFFFFFFFF
lCRC = &HFFFFFFFF

'1oCg
For i = 0 To l

  b = buf(i) Xor (lCRC And &HFF)
  '8rbgEVtg
  lCRC = (((lCRC And &HFFFFFF00) \ 256) And &HFFFFFF) Xor CRC32Table(b)
Next

'Ō0xFFFFFFFFƂXORƂ
lCRC = lCRC Xor &HFFFFFFFF

CRC = Hex(lCRC)
If Len(CRC) < 8 Then CRC = String(8 - Len(CRC), "0") + CRC

GetCRC32 = CRC

End Function

Function GetFileCRC32(fn As String) As String
't@CCRC32擾
Dim buf() As Byte
Dim l&

't@C̑݃`FbN
If Dir(fn) = "" Then Exit Function
l = FileLen(fn)

If l = 0 Then
  GetFileCRC32 = "00000000"
  Exit Function
End If

'I[v
ReDim buf(l - 1) As Byte

Open fn For Binary As 1
  Get 1, , buf()
Close

'CRCvZ
GetFileCRC32 = GetCRC32(buf())

End Function

Function GetFileCRC16(fn As String) As String
't@CCRC16擾
Dim buf() As Byte
Dim l&

't@C̑݃`FbN
If Dir(fn) = "" Then Exit Function
l = FileLen(fn)
If l = 0 Then
  GetFileCRC16 = "FFFF"
  Exit Function
End If

'I[v
ReDim buf(l - 1) As Byte

Open fn For Binary As 1
  Get 1, , buf()
Close

'CRCvZ
GetFileCRC16 = GetCRC16(buf())

End Function


Sub SetCRC32Table()

CRC32Table(0) = &H0&
CRC32Table(1) = &H77073096
CRC32Table(2) = &HEE0E612C
CRC32Table(3) = &H990951BA
CRC32Table(4) = &H76DC419
CRC32Table(5) = &H706AF48F
CRC32Table(6) = &HE963A535
CRC32Table(7) = &H9E6495A3
CRC32Table(8) = &HEDB8832
CRC32Table(9) = &H79DCB8A4
CRC32Table(10) = &HE0D5E91E
CRC32Table(11) = &H97D2D988
CRC32Table(12) = &H9B64C2B
CRC32Table(13) = &H7EB17CBD
CRC32Table(14) = &HE7B82D07
CRC32Table(15) = &H90BF1D91
CRC32Table(16) = &H1DB71064
CRC32Table(17) = &H6AB020F2
CRC32Table(18) = &HF3B97148
CRC32Table(19) = &H84BE41DE
CRC32Table(20) = &H1ADAD47D
CRC32Table(21) = &H6DDDE4EB
CRC32Table(22) = &HF4D4B551
CRC32Table(23) = &H83D385C7
CRC32Table(24) = &H136C9856
CRC32Table(25) = &H646BA8C0
CRC32Table(26) = &HFD62F97A
CRC32Table(27) = &H8A65C9EC
CRC32Table(28) = &H14015C4F
CRC32Table(29) = &H63066CD9
CRC32Table(30) = &HFA0F3D63
CRC32Table(31) = &H8D080DF5
CRC32Table(32) = &H3B6E20C8
CRC32Table(33) = &H4C69105E
CRC32Table(34) = &HD56041E4
CRC32Table(35) = &HA2677172
CRC32Table(36) = &H3C03E4D1
CRC32Table(37) = &H4B04D447
CRC32Table(38) = &HD20D85FD
CRC32Table(39) = &HA50AB56B
CRC32Table(40) = &H35B5A8FA
CRC32Table(41) = &H42B2986C
CRC32Table(42) = &HDBBBC9D6
CRC32Table(43) = &HACBCF940
CRC32Table(44) = &H32D86CE3
CRC32Table(45) = &H45DF5C75
CRC32Table(46) = &HDCD60DCF
CRC32Table(47) = &HABD13D59
CRC32Table(48) = &H26D930AC
CRC32Table(49) = &H51DE003A
CRC32Table(50) = &HC8D75180
CRC32Table(51) = &HBFD06116
CRC32Table(52) = &H21B4F4B5
CRC32Table(53) = &H56B3C423
CRC32Table(54) = &HCFBA9599
CRC32Table(55) = &HB8BDA50F
CRC32Table(56) = &H2802B89E
CRC32Table(57) = &H5F058808
CRC32Table(58) = &HC60CD9B2
CRC32Table(59) = &HB10BE924
CRC32Table(60) = &H2F6F7C87
CRC32Table(61) = &H58684C11
CRC32Table(62) = &HC1611DAB
CRC32Table(63) = &HB6662D3D
CRC32Table(64) = &H76DC4190
CRC32Table(65) = &H1DB7106
CRC32Table(66) = &H98D220BC
CRC32Table(67) = &HEFD5102A
CRC32Table(68) = &H71B18589
CRC32Table(69) = &H6B6B51F
CRC32Table(70) = &H9FBFE4A5
CRC32Table(71) = &HE8B8D433
CRC32Table(72) = &H7807C9A2
CRC32Table(73) = &HF00F934
CRC32Table(74) = &H9609A88E
CRC32Table(75) = &HE10E9818
CRC32Table(76) = &H7F6A0DBB
CRC32Table(77) = &H86D3D2D
CRC32Table(78) = &H91646C97
CRC32Table(79) = &HE6635C01
CRC32Table(80) = &H6B6B51F4
CRC32Table(81) = &H1C6C6162
CRC32Table(82) = &H856530D8
CRC32Table(83) = &HF262004E
CRC32Table(84) = &H6C0695ED
CRC32Table(85) = &H1B01A57B
CRC32Table(86) = &H8208F4C1
CRC32Table(87) = &HF50FC457
CRC32Table(88) = &H65B0D9C6
CRC32Table(89) = &H12B7E950
CRC32Table(90) = &H8BBEB8EA
CRC32Table(91) = &HFCB9887C
CRC32Table(92) = &H62DD1DDF
CRC32Table(93) = &H15DA2D49
CRC32Table(94) = &H8CD37CF3
CRC32Table(95) = &HFBD44C65
CRC32Table(96) = &H4DB26158
CRC32Table(97) = &H3AB551CE
CRC32Table(98) = &HA3BC0074
CRC32Table(99) = &HD4BB30E2
CRC32Table(100) = &H4ADFA541
CRC32Table(101) = &H3DD895D7
CRC32Table(102) = &HA4D1C46D
CRC32Table(103) = &HD3D6F4FB
CRC32Table(104) = &H4369E96A
CRC32Table(105) = &H346ED9FC
CRC32Table(106) = &HAD678846
CRC32Table(107) = &HDA60B8D0
CRC32Table(108) = &H44042D73
CRC32Table(109) = &H33031DE5
CRC32Table(110) = &HAA0A4C5F
CRC32Table(111) = &HDD0D7CC9
CRC32Table(112) = &H5005713C
CRC32Table(113) = &H270241AA
CRC32Table(114) = &HBE0B1010
CRC32Table(115) = &HC90C2086
CRC32Table(116) = &H5768B525
CRC32Table(117) = &H206F85B3
CRC32Table(118) = &HB966D409
CRC32Table(119) = &HCE61E49F
CRC32Table(120) = &H5EDEF90E
CRC32Table(121) = &H29D9C998
CRC32Table(122) = &HB0D09822
CRC32Table(123) = &HC7D7A8B4
CRC32Table(124) = &H59B33D17
CRC32Table(125) = &H2EB40D81
CRC32Table(126) = &HB7BD5C3B
CRC32Table(127) = &HC0BA6CAD
CRC32Table(128) = &HEDB88320
CRC32Table(129) = &H9ABFB3B6
CRC32Table(130) = &H3B6E20C
CRC32Table(131) = &H74B1D29A
CRC32Table(132) = &HEAD54739
CRC32Table(133) = &H9DD277AF
CRC32Table(134) = &H4DB2615
CRC32Table(135) = &H73DC1683
CRC32Table(136) = &HE3630B12
CRC32Table(137) = &H94643B84
CRC32Table(138) = &HD6D6A3E
CRC32Table(139) = &H7A6A5AA8
CRC32Table(140) = &HE40ECF0B
CRC32Table(141) = &H9309FF9D
CRC32Table(142) = &HA00AE27
CRC32Table(143) = &H7D079EB1
CRC32Table(144) = &HF00F9344
CRC32Table(145) = &H8708A3D2
CRC32Table(146) = &H1E01F268
CRC32Table(147) = &H6906C2FE
CRC32Table(148) = &HF762575D
CRC32Table(149) = &H806567CB
CRC32Table(150) = &H196C3671
CRC32Table(151) = &H6E6B06E7
CRC32Table(152) = &HFED41B76
CRC32Table(153) = &H89D32BE0
CRC32Table(154) = &H10DA7A5A
CRC32Table(155) = &H67DD4ACC
CRC32Table(156) = &HF9B9DF6F
CRC32Table(157) = &H8EBEEFF9
CRC32Table(158) = &H17B7BE43
CRC32Table(159) = &H60B08ED5
CRC32Table(160) = &HD6D6A3E8
CRC32Table(161) = &HA1D1937E
CRC32Table(162) = &H38D8C2C4
CRC32Table(163) = &H4FDFF252
CRC32Table(164) = &HD1BB67F1
CRC32Table(165) = &HA6BC5767
CRC32Table(166) = &H3FB506DD
CRC32Table(167) = &H48B2364B
CRC32Table(168) = &HD80D2BDA
CRC32Table(169) = &HAF0A1B4C
CRC32Table(170) = &H36034AF6
CRC32Table(171) = &H41047A60
CRC32Table(172) = &HDF60EFC3
CRC32Table(173) = &HA867DF55
CRC32Table(174) = &H316E8EEF
CRC32Table(175) = &H4669BE79
CRC32Table(176) = &HCB61B38C
CRC32Table(177) = &HBC66831A
CRC32Table(178) = &H256FD2A0
CRC32Table(179) = &H5268E236
CRC32Table(180) = &HCC0C7795
CRC32Table(181) = &HBB0B4703
CRC32Table(182) = &H220216B9
CRC32Table(183) = &H5505262F
CRC32Table(184) = &HC5BA3BBE
CRC32Table(185) = &HB2BD0B28
CRC32Table(186) = &H2BB45A92
CRC32Table(187) = &H5CB36A04
CRC32Table(188) = &HC2D7FFA7
CRC32Table(189) = &HB5D0CF31
CRC32Table(190) = &H2CD99E8B
CRC32Table(191) = &H5BDEAE1D
CRC32Table(192) = &H9B64C2B0
CRC32Table(193) = &HEC63F226
CRC32Table(194) = &H756AA39C
CRC32Table(195) = &H26D930A
CRC32Table(196) = &H9C0906A9
CRC32Table(197) = &HEB0E363F
CRC32Table(198) = &H72076785
CRC32Table(199) = &H5005713
CRC32Table(200) = &H95BF4A82
CRC32Table(201) = &HE2B87A14
CRC32Table(202) = &H7BB12BAE
CRC32Table(203) = &HCB61B38
CRC32Table(204) = &H92D28E9B
CRC32Table(205) = &HE5D5BE0D
CRC32Table(206) = &H7CDCEFB7
CRC32Table(207) = &HBDBDF21
CRC32Table(208) = &H86D3D2D4
CRC32Table(209) = &HF1D4E242
CRC32Table(210) = &H68DDB3F8
CRC32Table(211) = &H1FDA836E
CRC32Table(212) = &H81BE16CD
CRC32Table(213) = &HF6B9265B
CRC32Table(214) = &H6FB077E1
CRC32Table(215) = &H18B74777
CRC32Table(216) = &H88085AE6
CRC32Table(217) = &HFF0F6A70
CRC32Table(218) = &H66063BCA
CRC32Table(219) = &H11010B5C
CRC32Table(220) = &H8F659EFF
CRC32Table(221) = &HF862AE69
CRC32Table(222) = &H616BFFD3
CRC32Table(223) = &H166CCF45
CRC32Table(224) = &HA00AE278
CRC32Table(225) = &HD70DD2EE
CRC32Table(226) = &H4E048354
CRC32Table(227) = &H3903B3C2
CRC32Table(228) = &HA7672661
CRC32Table(229) = &HD06016F7
CRC32Table(230) = &H4969474D
CRC32Table(231) = &H3E6E77DB
CRC32Table(232) = &HAED16A4A
CRC32Table(233) = &HD9D65ADC
CRC32Table(234) = &H40DF0B66
CRC32Table(235) = &H37D83BF0
CRC32Table(236) = &HA9BCAE53
CRC32Table(237) = &HDEBB9EC5
CRC32Table(238) = &H47B2CF7F
CRC32Table(239) = &H30B5FFE9
CRC32Table(240) = &HBDBDF21C
CRC32Table(241) = &HCABAC28A
CRC32Table(242) = &H53B39330
CRC32Table(243) = &H24B4A3A6
CRC32Table(244) = &HBAD03605
CRC32Table(245) = &HCDD70693
CRC32Table(246) = &H54DE5729
CRC32Table(247) = &H23D967BF
CRC32Table(248) = &HB3667A2E
CRC32Table(249) = &HC4614AB8
CRC32Table(250) = &H5D681B02
CRC32Table(251) = &H2A6F2B94
CRC32Table(252) = &HB40BBE37
CRC32Table(253) = &HC30C8EA1
CRC32Table(254) = &H5A05DF1B
CRC32Table(255) = &H2D02EF8D

End Sub

Sub SetCRC16Table()

CRC16Table(0) = &H0&
CRC16Table(1) = &H1189&
CRC16Table(2) = &H2312&
CRC16Table(3) = &H329B&
CRC16Table(4) = &H4624&
CRC16Table(5) = &H57AD&
CRC16Table(6) = &H6536&
CRC16Table(7) = &H74BF&
CRC16Table(8) = &H8C48&
CRC16Table(9) = &H9DC1&
CRC16Table(10) = &HAF5A&
CRC16Table(11) = &HBED3&
CRC16Table(12) = &HCA6C&
CRC16Table(13) = &HDBE5&
CRC16Table(14) = &HE97E&
CRC16Table(15) = &HF8F7&
CRC16Table(16) = &H1081&
CRC16Table(17) = &H108&
CRC16Table(18) = &H3393&
CRC16Table(19) = &H221A&
CRC16Table(20) = &H56A5&
CRC16Table(21) = &H472C&
CRC16Table(22) = &H75B7&
CRC16Table(23) = &H643E&
CRC16Table(24) = &H9CC9&
CRC16Table(25) = &H8D40&
CRC16Table(26) = &HBFDB&
CRC16Table(27) = &HAE52&
CRC16Table(28) = &HDAED&
CRC16Table(29) = &HCB64&
CRC16Table(30) = &HF9FF&
CRC16Table(31) = &HE876&
CRC16Table(32) = &H2102&
CRC16Table(33) = &H308B&
CRC16Table(34) = &H210&
CRC16Table(35) = &H1399&
CRC16Table(36) = &H6726&
CRC16Table(37) = &H76AF&
CRC16Table(38) = &H4434&
CRC16Table(39) = &H55BD&
CRC16Table(40) = &HAD4A&
CRC16Table(41) = &HBCC3&
CRC16Table(42) = &H8E58&
CRC16Table(43) = &H9FD1&
CRC16Table(44) = &HEB6E&
CRC16Table(45) = &HFAE7&
CRC16Table(46) = &HC87C&
CRC16Table(47) = &HD9F5&
CRC16Table(48) = &H3183&
CRC16Table(49) = &H200A&
CRC16Table(50) = &H1291&
CRC16Table(51) = &H318&
CRC16Table(52) = &H77A7&
CRC16Table(53) = &H662E&
CRC16Table(54) = &H54B5&
CRC16Table(55) = &H453C&
CRC16Table(56) = &HBDCB&
CRC16Table(57) = &HAC42&
CRC16Table(58) = &H9ED9&
CRC16Table(59) = &H8F50&
CRC16Table(60) = &HFBEF&
CRC16Table(61) = &HEA66&
CRC16Table(62) = &HD8FD&
CRC16Table(63) = &HC974&
CRC16Table(64) = &H4204&
CRC16Table(65) = &H538D&
CRC16Table(66) = &H6116&
CRC16Table(67) = &H709F&
CRC16Table(68) = &H420&
CRC16Table(69) = &H15A9&
CRC16Table(70) = &H2732&
CRC16Table(71) = &H36BB&
CRC16Table(72) = &HCE4C&
CRC16Table(73) = &HDFC5&
CRC16Table(74) = &HED5E&
CRC16Table(75) = &HFCD7&
CRC16Table(76) = &H8868&
CRC16Table(77) = &H99E1&
CRC16Table(78) = &HAB7A&
CRC16Table(79) = &HBAF3&
CRC16Table(80) = &H5285&
CRC16Table(81) = &H430C&
CRC16Table(82) = &H7197&
CRC16Table(83) = &H601E&
CRC16Table(84) = &H14A1&
CRC16Table(85) = &H528&
CRC16Table(86) = &H37B3&
CRC16Table(87) = &H263A&
CRC16Table(88) = &HDECD&
CRC16Table(89) = &HCF44&
CRC16Table(90) = &HFDDF&
CRC16Table(91) = &HEC56&
CRC16Table(92) = &H98E9&
CRC16Table(93) = &H8960&
CRC16Table(94) = &HBBFB&
CRC16Table(95) = &HAA72&
CRC16Table(96) = &H6306&
CRC16Table(97) = &H728F&
CRC16Table(98) = &H4014&
CRC16Table(99) = &H519D&
CRC16Table(100) = &H2522&
CRC16Table(101) = &H34AB&
CRC16Table(102) = &H630&
CRC16Table(103) = &H17B9&
CRC16Table(104) = &HEF4E&
CRC16Table(105) = &HFEC7&
CRC16Table(106) = &HCC5C&
CRC16Table(107) = &HDDD5&
CRC16Table(108) = &HA96A&
CRC16Table(109) = &HB8E3&
CRC16Table(110) = &H8A78&
CRC16Table(111) = &H9BF1&
CRC16Table(112) = &H7387&
CRC16Table(113) = &H620E&
CRC16Table(114) = &H5095&
CRC16Table(115) = &H411C&
CRC16Table(116) = &H35A3&
CRC16Table(117) = &H242A&
CRC16Table(118) = &H16B1&
CRC16Table(119) = &H738&
CRC16Table(120) = &HFFCF&
CRC16Table(121) = &HEE46&
CRC16Table(122) = &HDCDD&
CRC16Table(123) = &HCD54&
CRC16Table(124) = &HB9EB&
CRC16Table(125) = &HA862&
CRC16Table(126) = &H9AF9&
CRC16Table(127) = &H8B70&
CRC16Table(128) = &H8408&
CRC16Table(129) = &H9581&
CRC16Table(130) = &HA71A&
CRC16Table(131) = &HB693&
CRC16Table(132) = &HC22C&
CRC16Table(133) = &HD3A5&
CRC16Table(134) = &HE13E&
CRC16Table(135) = &HF0B7&
CRC16Table(136) = &H840&
CRC16Table(137) = &H19C9&
CRC16Table(138) = &H2B52&
CRC16Table(139) = &H3ADB&
CRC16Table(140) = &H4E64&
CRC16Table(141) = &H5FED&
CRC16Table(142) = &H6D76&
CRC16Table(143) = &H7CFF&
CRC16Table(144) = &H9489&
CRC16Table(145) = &H8500&
CRC16Table(146) = &HB79B&
CRC16Table(147) = &HA612&
CRC16Table(148) = &HD2AD&
CRC16Table(149) = &HC324&
CRC16Table(150) = &HF1BF&
CRC16Table(151) = &HE036&
CRC16Table(152) = &H18C1&
CRC16Table(153) = &H948&
CRC16Table(154) = &H3BD3&
CRC16Table(155) = &H2A5A&
CRC16Table(156) = &H5EE5&
CRC16Table(157) = &H4F6C&
CRC16Table(158) = &H7DF7&
CRC16Table(159) = &H6C7E&
CRC16Table(160) = &HA50A&
CRC16Table(161) = &HB483&
CRC16Table(162) = &H8618&
CRC16Table(163) = &H9791&
CRC16Table(164) = &HE32E&
CRC16Table(165) = &HF2A7&
CRC16Table(166) = &HC03C&
CRC16Table(167) = &HD1B5&
CRC16Table(168) = &H2942&
CRC16Table(169) = &H38CB&
CRC16Table(170) = &HA50&
CRC16Table(171) = &H1BD9&
CRC16Table(172) = &H6F66&
CRC16Table(173) = &H7EEF&
CRC16Table(174) = &H4C74&
CRC16Table(175) = &H5DFD&
CRC16Table(176) = &HB58B&
CRC16Table(177) = &HA402&
CRC16Table(178) = &H9699&
CRC16Table(179) = &H8710&
CRC16Table(180) = &HF3AF&
CRC16Table(181) = &HE226&
CRC16Table(182) = &HD0BD&
CRC16Table(183) = &HC134&
CRC16Table(184) = &H39C3&
CRC16Table(185) = &H284A&
CRC16Table(186) = &H1AD1&
CRC16Table(187) = &HB58&
CRC16Table(188) = &H7FE7&
CRC16Table(189) = &H6E6E&
CRC16Table(190) = &H5CF5&
CRC16Table(191) = &H4D7C&
CRC16Table(192) = &HC60C&
CRC16Table(193) = &HD785&
CRC16Table(194) = &HE51E&
CRC16Table(195) = &HF497&
CRC16Table(196) = &H8028&
CRC16Table(197) = &H91A1&
CRC16Table(198) = &HA33A&
CRC16Table(199) = &HB2B3&
CRC16Table(200) = &H4A44&
CRC16Table(201) = &H5BCD&
CRC16Table(202) = &H6956&
CRC16Table(203) = &H78DF&
CRC16Table(204) = &HC60&
CRC16Table(205) = &H1DE9&
CRC16Table(206) = &H2F72&
CRC16Table(207) = &H3EFB&
CRC16Table(208) = &HD68D&
CRC16Table(209) = &HC704&
CRC16Table(210) = &HF59F&
CRC16Table(211) = &HE416&
CRC16Table(212) = &H90A9&
CRC16Table(213) = &H8120&
CRC16Table(214) = &HB3BB&
CRC16Table(215) = &HA232&
CRC16Table(216) = &H5AC5&
CRC16Table(217) = &H4B4C&
CRC16Table(218) = &H79D7&
CRC16Table(219) = &H685E&
CRC16Table(220) = &H1CE1&
CRC16Table(221) = &HD68&
CRC16Table(222) = &H3FF3&
CRC16Table(223) = &H2E7A&
CRC16Table(224) = &HE70E&
CRC16Table(225) = &HF687&
CRC16Table(226) = &HC41C&
CRC16Table(227) = &HD595&
CRC16Table(228) = &HA12A&
CRC16Table(229) = &HB0A3&
CRC16Table(230) = &H8238&
CRC16Table(231) = &H93B1&
CRC16Table(232) = &H6B46&
CRC16Table(233) = &H7ACF&
CRC16Table(234) = &H4854&
CRC16Table(235) = &H59DD&
CRC16Table(236) = &H2D62&
CRC16Table(237) = &H3CEB&
CRC16Table(238) = &HE70&
CRC16Table(239) = &H1FF9&
CRC16Table(240) = &HF78F&
CRC16Table(241) = &HE606&
CRC16Table(242) = &HD49D&
CRC16Table(243) = &HC514&
CRC16Table(244) = &HB1AB&
CRC16Table(245) = &HA022&
CRC16Table(246) = &H92B9&
CRC16Table(247) = &H8330&
CRC16Table(248) = &H7BC7&
CRC16Table(249) = &H6A4E&
CRC16Table(250) = &H58D5&
CRC16Table(251) = &H495C&
CRC16Table(252) = &H3DE3&
CRC16Table(253) = &H2C6A&
CRC16Table(254) = &H1EF1&
CRC16Table(255) = &HF78&

End Sub

